<template>
    <div>
        <crumbs title="产品线管理">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="产品名称：">
                    <el-input size="mini" v-model="filter.proName" placeholder="产品名称"></el-input>
                    </el-select>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                    <router-link to="/admin/LT-CPXGL-TJCPX" style="margin:0 10px">
                        <el-button size="mini" type="warning">添加产品线</el-button>
                    </router-link>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        prop="gmtCreate"
                        label="建立时间"
                        :show-overflow-tooltip="true">
                </el-table-column>
                <el-table-column
                        prop="name"
                        label="产品名称">
                </el-table-column>
                <el-table-column
                        prop="url"
                        label="URL"
                        width="180">
                </el-table-column>
                <el-table-column
                        prop="decription"
                        label="描述" width="120">
                </el-table-column>
                <el-table-column
                        prop="accessTypeName"
                        label="接入方式"
                        :show-overflow-tooltip="true">
                    <!--<template slot-scope="scope">
                        <span v-for="item in linkIn" class="status-span">{{item.name}},</span>
                    </template>-->
                </el-table-column>
                <el-table-column
                        prop="chargeTypeName"
                        label="收费模式"
                        :show-overflow-tooltip="true">
                    <!--<template slot-scope="scope">
                        <span v-for="item in pays" class="status-span">{{item.name}},</span>
                    </template>-->
                </el-table-column>
                <el-table-column
                        prop="oppendedNum"
                        label="开通机构数量">
                </el-table-column>
                <el-table-column
                        prop="trialStatusName"
                        label="试用状态">
                </el-table-column>
                <el-table-column
                        prop="trialUrl"
                        label="试用URL"
                        width="180">
                </el-table-column>
                <el-table-column
                        label="状态">
                    <template slot-scope="scope">
                        <span v-if="scope.row.serviceStatus == 0">已停用</span>
                        <span v-if="scope.row.serviceStatus == 1">已启用</span>
                    </template>
                </el-table-column>
                <el-table-column
                        label="操作" width="150">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="toEditProduct(scope.row)">修改</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" @click="showDelDialog(scope.row.id)">删除</el-button>
                        <span style="margin:0 3px;">|</span>
                        <el-button type="text" size="small" v-if="scope.row.serviceStatus == 0" @click="updateServiceStatus(scope.row.id,1)">启用</el-button>
                        <el-button type="text" size="small" v-if="scope.row.serviceStatus == 1" @click="updateServiceStatus(scope.row.id,0)">停用</el-button>
                    </template>
                </el-table-column>
                <el-table-column
                        label="接入明细">
                    <template slot-scope="scope">
                        <el-button type="text" size="small" @click="getDetailList(scope.row.id)">详情</el-button>
                        <!-- <router-link :to="{name:'productDetail', params:{productId:scope.row.id}}"><el-button type="text" size="small">详情</el-button></router-link> -->
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination v-if="total>pageSize"
                           :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           layout="total,prev, pager, next, jumper"
                           :total="total">
            </el-pagination>
        </div>

    </div>
</template>

<script>
  import api from '@api/admin.js';
  import utils from '@api/utils.js';

  export default {
    name: 'product-lines-manage',
    data: function () {
      return {
        list: [],
        cacheData: {},
        currentPage: 1,
        pageSize: 10,
        total: 0,
        linkIn:[],
        pays:[],
        filter: {
          proName: ''
        }
      }
    },
    created() {
      this.getDataList();
      /*const enums = JSON.parse(localStorage.getItem('enumsData'));
      this.linkIn = enums&&enums.accessTypeEnum;
      this.pays = enums&&enums.chargeTypeEnum;*/
    },
    methods: {
      toEditProduct(row){
        this.$router.push({
          name:'editProductLine',
          params: {info:row}
        })
      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList() {
        const param = this.getFilterItems();
        api.getProductLinesManage(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            this.list = data.records;
            this.cacheData[param.current] = data.records;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getDetailList(id) {
        const param = {productId: id,};
        api.getProductDetail(param).then((res) => {
          if (res.data.code == '0') {
            this.$router.push({name:'productDetail', params:{productId: id}})
          } else {
            this.$message({
              showClose: true,
              message:res.data.msg,
              type:'warning'
            });
            this.getDataList()  //刷新列表
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getFilterItems() {
        const param = {
          name: this.filter.proName,
          current: this.currentPage,
          size: this.pageSize
        };
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        if (this.cacheData[next]) {       //如果已请求过该页数据，则使用缓存不重复请求
          this.list = this.cacheData[next];
        } else {
          this.getDataList();
        }
      },
      updateServiceStatus(id,serviceStatus){
        const txt = serviceStatus==0?'停用':'启用';
        this.showConfirmDialog('确定要'+txt+'该产品线吗？',()=>{
          api.updateServiceStatus({id,serviceStatus}).then((res)=>{
            if(res.data.code=='0'){
              this.getDataList();
              this.warning(res.data.msg||'操作成功','success');
            }else{
              this.warning(res.data.msg);
              this.getDataList();
            }
          }).catch((error)=>{
            this.warning(error);
          });
        });

      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(id){
        this.showConfirmDialog('确定要删除该产品线吗？',()=>{
          api.delProductLine({id}).then((res)=>{
            if(res.data.code=='0'){
              this.warning(res.data.msg||'操作成功','success');
              this.getDataList();
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      }
    }
  }
</script>

<style lang="less">
    @import "../../less/admin.less";
    .status-span{
        font-size: 12px;
        margin-right:10px;
        color: unset;
    }
</style>